var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import { isBoolean, isNumber, isUndefined, nth } from 'lodash';
import { useEffect, useRef, useState } from 'react';
import { useAsync, useEvent, useId, useRefExtra } from '@react-devui/hooks';
import { LeftOutlined, RightOutlined } from '@react-devui/icons';
import { getClassName } from '@react-devui/utils';
import { useDValue } from '../../hooks';
import { registerComponentMate } from '../../utils';
import { useComponentConfig, usePrefixConfig } from '../root';
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DSlides' });
export function DSlides(props) {
    var _a;
    const _b = useComponentConfig(COMPONENT_NAME, props), { dList, dActive, dAutoplay = 0, dArrow = 'hover', dPagination = true, dEffect = 'slide', dVertical = false, onActiveChange } = _b, restProps = __rest(_b, ["dList", "dActive", "dAutoplay", "dArrow", "dPagination", "dEffect", "dVertical", "onActiveChange"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    //#region Ref
    const slidesRef = useRef(null);
    const windowRef = useRefExtra(() => window);
    //#endregion
    const dataRef = useRef({
        startDragTime: 0,
    });
    const async = useAsync();
    const uniqueId = useId();
    const viewId = `${dPrefix}slides-view-${uniqueId}`;
    const autoplay = Object.assign({ delay: 0, stopOnLast: false, pauseOnMouseEnter: true }, isNumber(dAutoplay) ? { delay: dAutoplay } : dAutoplay);
    const pagination = Object.assign({ visible: true, dynamic: false }, isBoolean(dPagination) ? { visible: dPagination } : dPagination === 'hover' ? { visible: 'hover' } : dPagination);
    const [activeId, changeActiveId] = useDValue((_a = nth(dList, 0)) === null || _a === void 0 ? void 0 : _a.id, dActive, (id) => {
        if (onActiveChange) {
            const slide = dList.find((s) => s.id === id);
            if (slide) {
                onActiveChange(id, slide);
            }
        }
    });
    const [mouseEnter, setMouseEnter] = useState(false);
    const activeIndex = dList.findIndex((s) => s.id === activeId);
    useEffect(() => {
        if (slidesRef.current) {
            let size = 0;
            const slideEls = slidesRef.current.querySelectorAll(`.${dPrefix}slides__slide`);
            slideEls.forEach((el) => {
                const index = Number(el.dataset['index']);
                if (index < activeIndex) {
                    size += el[dVertical ? 'offsetHeight' : 'offsetWidth'];
                }
                else if (index === activeIndex) {
                    slidesRef.current.style.height = el.offsetHeight + 'px';
                }
            });
            const containerEl = slidesRef.current.querySelector(`.${dPrefix}slides__container`);
            containerEl.style.transform = dEffect === 'slide' ? `translate${dVertical ? 'Y' : 'X'}(calc(-${size}px + ${dragDistance}px))` : '';
        }
    });
    useEffect(() => {
        var _a, _b;
        if (autoplay.delay === 0 ||
            (autoplay.stopOnLast && activeIndex === dList.length - 1) ||
            (autoplay.pauseOnMouseEnter && mouseEnter) ||
            listenDragEvent) {
            (_b = (_a = dataRef.current).clearTid) === null || _b === void 0 ? void 0 : _b.call(_a);
            dataRef.current.clearTid = undefined;
        }
        else if (isUndefined(dataRef.current.clearTid)) {
            dataRef.current.clearTid = async.setTimeout(() => {
                var _a;
                dataRef.current.clearTid = undefined;
                const id = (_a = nth(dList, (activeIndex + 1) % dList.length)) === null || _a === void 0 ? void 0 : _a.id;
                if (!isUndefined(id)) {
                    changeActiveId(id);
                }
            }, autoplay.delay, () => {
                dataRef.current.clearTid = undefined;
            });
        }
    });
    const [dragStartPosition, setDragStartPosition] = useState();
    const [dragDistance, setDragDistance] = useState(0);
    const [dragOpacity, setDragOpacity] = useState();
    const changeDragDistance = (distance) => {
        if (slidesRef.current) {
            const els = [];
            const slideEls = slidesRef.current.querySelectorAll(`.${dPrefix}slides__slide`);
            slideEls.forEach((el) => {
                const index = Number(el.dataset['index']);
                els[index] = el;
            });
            if (distance > 0) {
                let size = 0;
                for (let index = activeIndex - 1; index >= 0; index--) {
                    size += els[index][dVertical ? 'offsetHeight' : 'offsetWidth'];
                }
                const distanceValue = Math.abs(distance) > size
                    ? size +
                        Math.sin(Math.min((Math.abs(distance) - size) / (els[0][dVertical ? 'offsetHeight' : 'offsetWidth'] * 3), 1) * (Math.PI / 2)) *
                            els[0][dVertical ? 'offsetHeight' : 'offsetWidth']
                    : distance;
                setDragDistance(distanceValue);
                setDragOpacity({
                    index: activeIndex,
                    value: activeIndex === 0
                        ? 1
                        : Math.max(1 - Math.abs(distanceValue) / els[activeIndex - 1][dVertical ? 'offsetHeight' : 'offsetWidth'], 0),
                });
            }
            else {
                let size = 0;
                for (let index = activeIndex + 1; index < dList.length; index++) {
                    size += els[index][dVertical ? 'offsetHeight' : 'offsetWidth'];
                }
                const distanceValue = Math.abs(distance) > size
                    ? -(size +
                        Math.sin(Math.min((Math.abs(distance) - size) / (els[dList.length - 1][dVertical ? 'offsetHeight' : 'offsetWidth'] * 3), 1) *
                            (Math.PI / 2)) *
                            els[dList.length - 1][dVertical ? 'offsetHeight' : 'offsetWidth'])
                    : distance;
                setDragDistance(distanceValue);
                setDragOpacity({
                    index: Math.min(activeIndex + 1, dList.length - 1),
                    value: activeIndex === dList.length - 1
                        ? 1
                        : Math.min(Math.abs(distanceValue) / els[activeIndex + 1][dVertical ? 'offsetHeight' : 'offsetWidth'], 1),
                });
            }
        }
    };
    const handleDragEnd = () => {
        var _a, _b, _c, _d;
        if (slidesRef.current) {
            const els = [];
            const slideEls = slidesRef.current.querySelectorAll(`.${dPrefix}slides__slide`);
            slideEls.forEach((el) => {
                const index = Number(el.dataset['index']);
                els[index] = el;
            });
            if (dragDistance > 0) {
                let newIndex = activeIndex;
                let size = 0;
                for (let index = activeIndex - 1; index >= 0; index--) {
                    if (Math.abs(dragDistance) > size + els[index][dVertical ? 'offsetHeight' : 'offsetWidth'] / 2) {
                        size += els[index][dVertical ? 'offsetHeight' : 'offsetWidth'];
                        newIndex = index;
                    }
                    else {
                        break;
                    }
                }
                if (newIndex === activeIndex) {
                    if (performance.now() - dataRef.current.startDragTime < 300 && Math.abs(dragDistance) > 30) {
                        const id = (_a = nth(dList, Math.max(newIndex - 1, 0))) === null || _a === void 0 ? void 0 : _a.id;
                        if (!isUndefined(id)) {
                            changeActiveId(id);
                        }
                    }
                }
                else {
                    const id = (_b = nth(dList, newIndex)) === null || _b === void 0 ? void 0 : _b.id;
                    if (!isUndefined(id)) {
                        changeActiveId(id);
                    }
                }
            }
            else {
                let newIndex = activeIndex;
                let size = 0;
                for (let index = activeIndex + 1; index < dList.length; index++) {
                    if (Math.abs(dragDistance) > size + els[index][dVertical ? 'offsetHeight' : 'offsetWidth'] / 2) {
                        size += els[index][dVertical ? 'offsetHeight' : 'offsetWidth'];
                        newIndex = index;
                    }
                    else {
                        break;
                    }
                }
                if (newIndex === activeIndex) {
                    if (performance.now() - dataRef.current.startDragTime < 300 && Math.abs(dragDistance) > 30) {
                        const id = (_c = nth(dList, Math.min(newIndex + 1, dList.length - 1))) === null || _c === void 0 ? void 0 : _c.id;
                        if (!isUndefined(id)) {
                            changeActiveId(id);
                        }
                    }
                }
                else {
                    const id = (_d = nth(dList, newIndex)) === null || _d === void 0 ? void 0 : _d.id;
                    if (!isUndefined(id)) {
                        changeActiveId(id);
                    }
                }
            }
        }
        setDragStartPosition(undefined);
        setDragDistance(0);
        setDragOpacity(undefined);
    };
    const listenDragEvent = !isUndefined(dragStartPosition);
    useEvent(windowRef, 'touchmove', (e) => {
        if (listenDragEvent) {
            e.preventDefault();
            changeDragDistance(e.touches[0][dVertical ? 'clientY' : 'clientX'] - dragStartPosition);
        }
    }, { passive: false }, !listenDragEvent);
    useEvent(windowRef, 'mousemove', (e) => {
        if (listenDragEvent) {
            e.preventDefault();
            changeDragDistance(e[dVertical ? 'clientY' : 'clientX'] - dragStartPosition);
        }
    }, {}, !listenDragEvent);
    useEvent(windowRef, 'mouseup', () => {
        handleDragEnd();
    }, {}, !listenDragEvent);
    return (_jsxs("div", Object.assign({}, restProps, { ref: slidesRef, className: getClassName(restProps.className, `${dPrefix}slides`, {
            [`${dPrefix}slides--vertical`]: dVertical,
            [`${dPrefix}slides--fade`]: dEffect === 'fade',
        }), onMouseEnter: (e) => {
            var _a;
            (_a = restProps.onMouseEnter) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
            setMouseEnter(true);
        }, onMouseLeave: (e) => {
            var _a;
            (_a = restProps.onMouseLeave) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
            setMouseEnter(false);
        } }, { children: [_jsx("div", Object.assign({ className: `${dPrefix}slides__container`, id: viewId, style: { transition: listenDragEvent ? 'none' : undefined }, role: "region", "aria-live": "polite", onMouseDown: (e) => {
                    e.preventDefault();
                    if (e.button === 0) {
                        setDragStartPosition(e[dVertical ? 'clientY' : 'clientX']);
                        dataRef.current.startDragTime = performance.now();
                    }
                }, onTouchStart: (e) => {
                    setDragStartPosition(e.touches[0][dVertical ? 'clientY' : 'clientX']);
                    dataRef.current.startDragTime = performance.now();
                }, onTouchEnd: () => {
                    handleDragEnd();
                } }, { children: dList.map((slide, index) => {
                    let opacity = index <= activeIndex ? 1 : 0;
                    if (listenDragEvent && dragOpacity && dragOpacity.index === index) {
                        opacity = dragOpacity.value;
                    }
                    return (_jsx("div", Object.assign({ className: `${dPrefix}slides__slide`, style: dEffect === 'slide'
                            ? undefined
                            : {
                                opacity,
                                transition: listenDragEvent ? 'none' : undefined,
                            }, "aria-hidden": slide.id !== activeId, "data-index": index }, { children: slide.content }), slide.id));
                }) })), (dArrow === true || dArrow === 'hover') && (_jsxs(_Fragment, { children: [_jsx("button", Object.assign({ className: getClassName(`${dPrefix}slides__arrow`, `${dPrefix}slides__arrow--prev`, {
                            'is-hidden': dArrow === 'hover' && !mouseEnter,
                        }), tabIndex: -1, disabled: activeIndex === 0, onClick: () => {
                            var _a;
                            const id = (_a = nth(dList, activeIndex - 1)) === null || _a === void 0 ? void 0 : _a.id;
                            if (!isUndefined(id)) {
                                changeActiveId(id);
                            }
                        } }, { children: _jsx(LeftOutlined, {}) })), _jsx("button", Object.assign({ className: getClassName(`${dPrefix}slides__arrow`, `${dPrefix}slides__arrow--next`, {
                            'is-hidden': dArrow === 'hover' && !mouseEnter,
                        }), tabIndex: -1, disabled: activeIndex === dList.length - 1, onClick: () => {
                            var _a;
                            const id = (_a = nth(dList, activeIndex + 1)) === null || _a === void 0 ? void 0 : _a.id;
                            if (!isUndefined(id)) {
                                changeActiveId(id);
                            }
                        } }, { children: _jsx(RightOutlined, {}) }))] })), (pagination.visible === true || pagination.visible === 'hover') && (_jsx("div", Object.assign({ className: getClassName(`${dPrefix}slides__pagination`, {
                    [`${dPrefix}slides__pagination--dynamic`]: pagination.dynamic,
                    'is-hidden': pagination.visible === 'hover' && !mouseEnter,
                }), role: "radiogroup" }, { children: dList.map((slide, index) => {
                    const checked = activeId === slide.id;
                    return (_jsx("input", { className: getClassName(`${dPrefix}slides__pagination-radio`, {
                            [`${dPrefix}slides__pagination-radio--prev-1`]: pagination.dynamic && index - activeIndex === -1,
                            [`${dPrefix}slides__pagination-radio--prev-2`]: pagination.dynamic && index - activeIndex === -2,
                            [`${dPrefix}slides__pagination-radio--next-1`]: pagination.dynamic && index - activeIndex === 1,
                            [`${dPrefix}slides__pagination-radio--next-2`]: pagination.dynamic && index - activeIndex === 2,
                            'is-checked': checked,
                        }), style: { [dVertical ? 'top' : 'left']: pagination.dynamic ? 40 - 8 - 16 * activeIndex : undefined }, type: "radio", value: slide.id, checked: checked, name: uniqueId, title: slide.tooltip, "aria-checked": checked, "aria-controls": viewId, onChange: () => {
                            changeActiveId(slide.id);
                        } }, slide.id));
                }) })))] })));
}
